import { Connection } from '@salesforce/core-bundle';
import { ApexExecuteOptions, ExecuteAnonymousResponse, SoapResponse } from './types';
import type { HttpRequest } from '@jsforce/jsforce-node';
export declare class ExecuteService {
    readonly connection: Connection;
    constructor(connection: Connection);
    executeAnonymous(options: ApexExecuteOptions): Promise<ExecuteAnonymousResponse>;
    getApexCode(options: ApexExecuteOptions): Promise<string>;
    readApexFile(filepath: string): string;
    getUserInput(): Promise<string>;
    private buildExecRequest;
    jsonFormat(soapResponse: SoapResponse): ExecuteAnonymousResponse;
    connectionRequest(requestData: HttpRequest): Promise<SoapResponse>;
}
