import { Connection } from '@salesforce/core-bundle';
import { TestResultMessage } from './types';
import { Progress } from '../common';
import { ApexTestProgressValue, ApexTestQueueItem, TestRunIdResult } from '../tests/types';
import { Duration } from '@salesforce/kit';
export declare const DEFAULT_STREAMING_TIMEOUT_SEC = 14400;
export interface AsyncTestRun {
    runId: string;
    queueItem: ApexTestQueueItem;
}
export declare class Deferred<T> {
    promise: Promise<T>;
    resolve: Function;
    constructor();
}
export declare class StreamingClient {
    private client;
    private readonly conn;
    private progress?;
    subscribedTestRunId: string;
    private subscribedTestRunIdDeferred;
    get subscribedTestRunIdPromise(): Promise<string>;
    private removeTrailingSlashURL;
    getStreamURL(instanceUrl: string): string;
    constructor(connection: Connection, progress?: Progress<ApexTestProgressValue>);
    init(): Promise<void>;
    handshake(): Promise<void>;
    disconnect(): void;
    hasDisconnected: boolean;
    subscribe(action?: () => Promise<string>, testRunId?: string, timeout?: Duration): Promise<AsyncTestRun | TestRunIdResult>;
    private isValidTestRunID;
    handler(message?: TestResultMessage, runId?: string): Promise<ApexTestQueueItem>;
    private getCompletedTestRun;
}
